Bug 1283710 - getpwuid_r fails in statically linked multi threaded applications
getpwuid_r fails in statically linked multi threaded applications
Status: CLOSED DUPLICATE of bug 1475501
Product: Fedora
Classification: Fedora
Component: glibc (Show other bugs)
24
Unspecified Unspecified
unspecified Severity unspecified
: ---
: ---
Assigned To: glibc team
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2015-11-19 11:12 EST by Jakub Čajka
Modified: 2017-07-26 15:32 EDT (History)
8 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2017-07-26 15:32:30 EDT
Type: Bug
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: ---


Attachments (Terms of Use)
reproducer (1.06 KB, text/plain)
2015-11-19 11:12 EST, Jakub Čajka
no flags Details

  None (edit)
Description Jakub Čajka 2015-11-19 11:12:38 EST
Created attachment 1096765 [details]
reproducer

In attachment is reproduce.

This should affect all fedora releases.
In rawhide reproducer succeeds in 1st thread and then SEGFAULTs.
In f23 reproducer "succeeds", but incorrect data/usernames are outputted ("(null)"instead of "root").

I'm already in touch with codonell/fweimer, opening this bug to track this issue in Fedora.
Comment 1 Florian Weimer 2015-11-19 14:18:40 EST
The problem here is that the copy of libc.so.6 loaded later does not know of the threading state of the entire process.  In a sense, it is like creating a thread with clone(2) and then calling into glibc (although the static/dlmopen case works better because a thread descriptor has been set up).  Or TSRs in the good-old DOS days.

This will be quite difficult to fix, particularly documenting the aspects that cannot be realistically fixed.
Comment 2 Jan Kurik 2016-02-24 08:59:46 EST
This bug appears to have been reported against 'rawhide' during the Fedora 24 development cycle.
Changing version to '24'.

More information and reason for this action is here:
https://fedoraproject.org/wiki/Fedora_Program_Management/HouseKeeping/Fedora24#Rawhide_Rebase
Comment 3 Fedora End Of Life 2017-07-25 15:31:46 EDT
This message is a reminder that Fedora 24 is nearing its end of life.
Approximately 2 (two) weeks from now Fedora will stop maintaining
and issuing updates for Fedora 24. It is Fedora's policy to close all
bug reports from releases that are no longer maintained. At that time
this bug will be closed as EOL if it remains open with a Fedora  'version'
of '24'.

Package Maintainer: If you wish for this bug to remain open because you
plan to fix it in a currently maintained version, simply change the 'version'
to a later Fedora version.

Thank you for reporting this issue and we are sorry that we were not
able to fix it before Fedora 24 is end of life. If you would still like
to see this bug fixed and are able to reproduce it against a later version
of Fedora, you are encouraged  change the 'version' to a later Fedora
version prior this bug is closed as described in the policy above.

Although we aim to fix as many bugs as possible during every release's
lifetime, sometimes those efforts are overtaken by events. Often a
more recent Fedora release includes newer upstream software that fixes
bugs or makes them obsolete.
Comment 4 Carlos O'Donell 2017-07-26 15:32:30 EDT
This is equivalent to solving the static vs dynamic namespace issues, and similarly fixing dlmopen. We aren't going to fix this any time soon. So for F24 I'm going to mark this CLOSED/DUPLICATE of

*** This bug has been marked as a duplicate of bug 1475501 ***

Note You need to log in before you can comment on or make changes to this bug.